%define anolis_release 2
%define mod_name Test-Harness

Name:           perl-Test-Harness
Epoch:          1
Version:        3.44
Release:        %{anolis_release}%{?dist}
Summary:        Run Perl standard test scripts with statistics
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/%{mod_name}
Source0:        https://cpan.metacpan.org/authors/id/L/LE/LEONT/%{mod_name}-%{version}.tar.gz
Source1:        test.sh
Patch1:         0001-Test-Harness-3.38-Remove-shell-bangs.patch

BuildRequires:  make coreutils
BuildRequires:  perl-interpreter perl-generators
BuildRequires:  perl(warnings) perl(strict)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(base) perl(Config)
BuildRequires:  perl(Carp) perl(Benchmark)
BuildRequires:  perl(POSIX) perl(constant) 
BuildRequires:  perl(Errno) perl(Exporter)
BuildRequires:  perl(File::Path) perl(File::Find)
BuildRequires:  perl(File::Spec) perl(File::Basename)
BuildRequires:  perl(IO::Select) perl(IO::Handle)
BuildRequires:  perl(Text::ParseWords) perl(Getopt::Long)
BuildRequires:  perl(Time::HiRes) perl(Term::ANSIColor) perl(Encode)
BuildRequires:  perl(lib) perl(Symbol)
BuildRequires:  perl(Test::More) perl(Data::Dumper)
BuildRequires:  perl(IO::File) perl(File::Spec::Functions)
Suggests:       perl(Time::HiRes) perl(Term::ANSIColor)

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(My.*\\)
%global __requires_exclude %{__requires_exclude}|^perl\\(NoFork\\)
%global __requires_exclude %{__requires_exclude}|^perl\\(IO::c55Capture\\)
%global __requires_exclude %{__requires_exclude}|^perl\\(EmptyParser\\)
%global __requires_exclude %{__requires_exclude}|^perl\\(Dev::Null\\)

%global __requires_exclude_from %{?__requires_exclude_from:%__requires_exclude_from|}^%{_datadir}/doc

%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_datadir}/doc
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}

BuildArch:      noarch

%description
This package allows tests to be run and results automatically aggregated and
output to STDOUT.

%package        tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl-Test-Harness

%description    tests
Tests from %{name}. Execute them with "%{_libexecdir}/%{name}/test".

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -q -n %{mod_name}-%{version}
%patch1 -p1

# Help generators to recognize Perl scripts
for F in `find t -name *.t -o -name *.pl`; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL NO_PACKLIST=1 NO_PERLLOCAL=1 INSTALLDIRS=vendor
%make_build

%install
%make_install
%{_fixperms} %{buildroot}/*

# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
rm %{buildroot}%{_libexecdir}/%{name}/t/000-load.t
install -m 0755 %{SOURCE1} %{buildroot}%{_libexecdir}/%{name}/test

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%{_bindir}/prove
%{perl_vendorlib}/*
%{_mandir}/man1/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}/test
%{_libexecdir}/%{name}/t/*

%files doc
%doc README examples Changes-2.64 Changes 

%changelog
* Fri Apr 14 2023 Guyu Wang <guyu.wgy@linux.alibaba.com> - 1:3.44-2
- Optimise spec file

* Tue Feb 07 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:3.44-1
- update to 3.44

* Fri Feb 03 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:3.42-3
- remove versioned MODULE_COMPAT_ requires

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:3.42-2
- rebuild with perl 5.36.0

* Wed Apr 20 2022 Zhongling He <zhonglingh@linux.alibaba.com> - 1:3.42-1
- Init package from upstream v3.42
